// addunzip.h
//
// C/C++ header file for addUNZIP compression libraries
//
// Copyright  1995,1998 Stephen Darlington. All rights reserved.
//

#ifndef _ADDUNZIP_H
#define _ADDUNZIP_H

// Define the function import/export identifiers for use in dynamic import library
#ifndef DLLENTRY
#	if defined(__WIN32__) || defined(_WIN32)
#		define DLLENTRY extern __declspec(dllimport)
#	else
#		define DLLENTRY extern
#	endif
#endif

// Redefine the function import/export identifiers for use in static import library
#ifdef _STATIC_LIB
#	undef DLLENTRY
#	define DLLENTRY
#	undef WINAPI
#	define WINAPI
#endif

#ifndef _BYTE_T_DEFINED
#	define _BYTE_T_DEFINED
	typedef unsigned char BYTE_T;
#endif

#ifndef _BOOLEAN_T_DEFINED
#	define _BOOLEAN_T_DEFINED
	typedef char BOOLEAN_T;
#endif

#ifndef _UINT16_T_DEFINED
#	define _UINT16_T_DEFINED
	typedef unsigned short UINT16_T;
#endif

#ifndef _UINT32_T_DEFINED
#	define _UINT32_T_DEFINED
	typedef unsigned long UINT32_T;
#endif

#ifndef _CHAR_T_DEFINED
#	define _CHAR_T_DEFINED
	typedef char CHAR_T;
#endif

#ifndef _INT16_T_DEFINED
#	define _INT16_T_DEFINED
	typedef short INT16_T;
#endif

#ifndef _INT32_T_DEFINED
#	define _INT32_T_DEFINED
	typedef long INT32_T;
#endif

#ifndef _LPARAM_T_DEFINED
#	define _LPARAM_T_DEFINED
	typedef unsigned long LPARAM_T;
#endif

#ifndef _LPSTR_T_DEFINED
#	define _LPSTR_T_DEFINED
	typedef char FAR * LPSTR_T;
	typedef const char FAR * LPCSTR_T;
#endif

#ifndef _CALLBACKS_T_DEFINED
#	define _CALLBACKS_T_DEFINED
	typedef int (CALLBACK *CALLBACKFN)(UINT16_T, UINT16_T, LPSTR_T);
	typedef int (CALLBACK *CALLBACKFNEX)(UINT16_T, UINT16_T, LPSTR_T, LPARAM_T);
#endif

// function prototypes
#ifdef __cplusplus
extern "C"
{
#endif

DLLENTRY INT32_T WINAPI addUNZIP(void);
DLLENTRY INT16_T WINAPI addUNZIP_Abort(INT16_T);
DLLENTRY INT16_T WINAPI addUNZIP_ArchiveName(LPCSTR_T);
DLLENTRY INT16_T WINAPI addUNZIP_Decrypt(LPCSTR_T);
DLLENTRY INT16_T WINAPI addUNZIP_DisplayComment(INT16_T);
DLLENTRY INT16_T WINAPI addUNZIP_Exclude(LPCSTR_T);
DLLENTRY INT16_T WINAPI addUNZIP_ExcludeListFile(LPCSTR_T);
DLLENTRY INT16_T WINAPI addUNZIP_ExtractTo(LPCSTR_T cPath);
DLLENTRY INT16_T WINAPI addUNZIP_Freshen(INT16_T iFlag);
DLLENTRY INT16_T WINAPI addUNZIP_GetLastError(void);
DLLENTRY INT16_T WINAPI addUNZIP_GetLastWarning(void);
DLLENTRY void    WINAPI addUNZIP_GetVersion(UINT16_T *, UINT16_T *);
DLLENTRY INT16_T WINAPI addUNZIP_Include(LPCSTR_T files);
DLLENTRY INT16_T WINAPI addUNZIP_IncludeListFile(LPCSTR_T cFile);
DLLENTRY void    WINAPI addUNZIP_Initialise(void);
DLLENTRY INT32_T WINAPI addUNZIP_InMemory(LPSTR_T lpszInBuffer, UINT32_T u4_InLength, LPSTR_T lpszOutBuffer, UINT32_T u4_OutLength); // added
DLLENTRY INT16_T WINAPI addUNZIP_InstallCallback(CALLBACKFN fn);
DLLENTRY INT16_T WINAPI addUNZIP_InstallCallbackEx(CALLBACKFNEX cbFunction, LPARAM_T lParam); // added v0.69d
DLLENTRY INT16_T WINAPI addUNZIP_Overwrite(INT16_T iFlag);
DLLENTRY INT16_T WINAPI addUNZIP_Register(LPCSTR_T cName, UINT32_T iNumber);
DLLENTRY INT16_T WINAPI addUNZIP_RestoreAttributes(INT16_T iFlag);
DLLENTRY INT16_T WINAPI addUNZIP_RestoreStructure(INT16_T iFlag);
DLLENTRY INT16_T WINAPI addUNZIP_SaveConfiguration(LPCSTR_T szFile);
DLLENTRY INT16_T WINAPI addUNZIP_SetParentWindowHandle(HWND hwnd);
DLLENTRY INT16_T WINAPI addUNZIP_SetWindowHandle(HWND hwnd);
DLLENTRY INT16_T WINAPI addUNZIP_Test(INT16_T iFlag);
DLLENTRY INT16_T WINAPI addUNZIP_FromMemory(LPSTR_T, UINT32_T); // added v0.69d
DLLENTRY INT16_T WINAPI addUNZIP_ToMemory(LPSTR_T, UINT32_T);
DLLENTRY INT16_T WINAPI addUNZIP_Update(INT16_T iFlag);
DLLENTRY INT16_T WINAPI addUNZIP_View(INT16_T bFlag);

// constants for addUNZIP_Overwrite(...)
#define azOVERWRITE_QUERY 0x0a
#define azOVERWRITE_ALL   0x0b
#define azOVERWRITE_NONE  0x0c

// constants used in messages
#define azLIBRARY_ADDUNZIP 1

// constants for addUNZIP_RestoreAttributes(...)
#define azATTR_NONE 0
#define azATTR_READONLY 1
#define azATTR_HIDDEN 2
#define azATTR_SYSTEM 4
#define azATTR_ARCHIVE 32
#define azATTR_ALL 39

// addZIP & addUNZIP messages
#define AM_SEARCHING      0x0a
#define AM_ZIPCOMMENT     0x0b
#define AM_ZIPPING        0x0c
#define AM_ZIPPED         0x0d
#define AM_UNZIPPING      0x0e
#define AM_UNZIPPED       0x0f
#define AM_TESTING        0x10
#define AM_TESTED         0x11
#define AM_DELETING       0x12
#define AM_DELETED        0x13
#define AM_DISKCHANGE     0x14
#define AM_VIEW           0x15
#define AM_ERROR          0x16
#define AM_WARNING        0x17
#define AM_QUERYOVERWRITE 0x18
#define AM_COPYING        0x19
#define AM_COPIED         0x1a
//#define AM_REPAIRING      0x1b
//#define AM_FILECOMMENT    0x1c
//#define AM_PASSWORD       0x1d
#define AM_ABORT          0xff

// Constants for compression method in AM_VIEW
#define azCM_NONE 0              0x00
#define azCM_SHRUNK              0x0a
#define azCM_REDUCED_1           0x14
#define azCM_REDUCED_2           0x1e
#define azCM_REDUCED_3           0x28
#define azCM_REDUCED_4           0x32
#define azCM_IMPLODED            0x3c
#define azCM_TOKENISED           0x46
#define azCM_DEFLATED_NORMAL     0x50
#define azCM_DEFLATED_MAXIMUM    0x51
#define azCM_DEFLATED_FAST       0x52
#define azCM_DEFLATED_SUPERFAST  0x53
#define azCM_UNKNOWN             0xff

//Constants for whether file is encrypted or not in AM_VIEW
#define azFT_NOT_ENCRYPTED 0x00
#define azFT_ENCRYPTED     0x01

//Constants for whether file is text or binary in AM_VIEW
#define azFT_TEXT   0x00
#define azFT_BINARY 0x01

// Constants used in returning from a AM_QUERYOVERWRITE message
#define AQO_YES      0x00
#define AQO_YESTOALL 0x01
#define AQO_NO       0x02
#define AQO_NOTOALL  0x03
#define AQO_RENAME   0x04

#ifdef __cplusplus
}
#endif
#endif
