unit ADDZIPC;

interface

{
addzipu.pas - addZip utility functions

Borland Delphi interface unit for addZIP compression libraries
Copyright  1995,1997 Stephen Darlington. All rights reserved.

Borland Delphi interface unit created by Brad Clarke.
}

{ constants for addZIP_CreateSFX(...) }
Const azSFX_NO = $00;
Const azSFX_DOS16 = $01;
Const azSFX_DOS32 = $02;
Const azSFX_WIN16 = $03;
Const azSFX_WIN32 = $04;

{ constants for addZIP_SetCompressionLevel(...) }
Const azCOMPRESSION_NONE = $00;
Const azCOMPRESSION_MINIMUM = $01;
Const azCOMPRESSION_NORMAL = $02;
Const azCOMPRESSION_MAXIMUM = $03;

{ constants for addZIP_SaveStructure(...) }
Const azSTRUCTURE_NONE = $00;
Const azSTRUCTURE_RELATIVE = $01;
Const azSTRUCTURE_ABSOLUTE = $02;

{ constants for addZIP_Overwrite(...) }
Const azOVERWRITE_QUERY = $0a;
Const azOVERWRITE_ALL = $0b;
Const azOVERWRITE_NONE = $0c;

{ constants for addZIP_SetArchiveDate(); }
Const DATE_ORIGINAL = $00;
Const DATE_TODAY = $01;
Const DATE_OLDEST = $02;
Const DATE_NEWEST = $03;

{ constants for addZIP_IncludeXXX attribute functions }
Const azNEVER = $00; { files must never have this attribute set}
Const azYES = $01; { files may or may not have this attribute set}
Const azALWAYS = $ff; { files must always have this attribute set}

{ constants for addZIP_ClearAttributes(...) }
{ constants for addUNZIP_RestoreAttributes(...) }
Const azATTR_NONE = 0;
Const azATTR_READONLY = 1;
Const azATTR_HIDDEN = 2;
Const azATTR_SYSTEM = 4;
Const azATTR_ARCHIVE = 32;
Const azATTR_ALL = 39;

{ constants used in messages to identify library }
Const azLIBRARY_ADDZIP = 0;
Const azLIBRARY_ADDUNZIP = 1;

{ addZIP & addUNZIP messages }
Const AM_SEARCHING = $0a;
Const AM_ZIPCOMMENT = $0b;
Const AM_ZIPPING = $0c;
Const AM_ZIPPED = $0d;
Const AM_UNZIPPING = $0e;
Const AM_UNZIPPED = $0f;
Const AM_TESTING = $10;
Const AM_TESTED = $11;
Const AM_DELETING = $12;
Const AM_DELETED = $13;
Const AM_DISKCHANGE = $14;
Const AM_VIEW = $15;
Const AM_ERROR = $16;
Const AM_WARNING = $17;
Const AM_QUERYOVERWRITE = $18;
Const AM_COPYING = $19;
Const AM_COPIED = $1a;
Const AM_REPAIRING = $1b;
Const AM_FILECOMMENT = $1c;
Const AM_PASSWORD = $1d;
Const AM_ABORT = $ff;

{ Constants for compression method in AM_VIEW }
Const azCM_NONE = $00;
Const azCM_SHRUNK = $0a;
Const azCM_REDUCED_1 = $14;
Const azCM_REDUCED_2 = $1e;
Const azCM_REDUCED_3 = $28;
Const azCM_REDUCED_4 = $32;
Const azCM_IMPLODED = $3c;
Const azCM_TOKENISED = $46;
Const azCM_DEFLATED_NORMAL = $50;
Const azCM_DEFLATED_MAXIMUM = $51;
Const azCM_DEFLATED_FAST = $52;
Const azCM_DEFLATED_SUPERFAST = $53;
Const azCM_UNKNOWN = $ff;

{Constants for whether file is encrypted or not in AM_VIEW }
Const azFT_NOT_ENCRYPTED = $00;
Const azFT_ENCRYPTED = $01;

{Constants for whether file is text or binary in AM_VIEW }
Const azFT_TEXT = $00;
Const azFT_BINARY = $01;

{ Constants used in returning from a AM_QUERYOVERWRITE message }
Const azOW_YES = $00;
Const azOW_YES_TO_ALL = $01;
Const azOW_NO = $02;
Const azOW_NO_TO_ALL = $03;

implementation

end.
 