unit AZIP;

interface

uses
{$IFDEF WIN32}
  Windows;
{$ELSE}
  WinTypes, WinProcs;
{$ENDIF}

{
azip.pas

Borland Delphi interface unit for addZIP compression libraries
Copyright  1995,1997 Stephen Darlington. All rights reserved.

Borland Delphi interface unit created by Brad Clarke.
}

function addZIP: Integer ; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_ArchiveName(lpFile : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_BuildSFX(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_ClearAttributes(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Comment(lpComment : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Delete(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_DeleteComment(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_DisplayComment(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Encrypt(lpPassword : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Exclude(lpFiles : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_ExcludeListFile(lpFile : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Freshen(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_GetLastError: Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_GetLastWarning: Integer; {$ifdef Win32} stdcall; {$endif Win32}

Procedure addZIP_GetVersion(var Major : Integer; var Minor : Integer); {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Include(lpFiles : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_IncludeFilesNewer(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_IncludeFilesOlder(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_IncludeArchive(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_IncludeDirectoryEntries(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_IncludeHidden(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_IncludeReadOnly(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_IncludeSystem(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_IncludeListFile(lpFile : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}

procedure addZIP_Initialise; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_InstallCallback(fCallback: Pointer): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Move(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Overwrite(iFlag : Integer): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Recurse(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Register(lpUserName : PChar; lCode : LongInt): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SaveAttributes(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SaveConfiguration(lpFile : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SaveRelativeTo(lpPath : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SaveStructure(iFlag : Integer): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SetArchiveDate(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SetCompressionLevel(iFlag : Integer): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SetParentWindowHandle(hWnd : THandle): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SetTempDrive(lpPath : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SetWindowHandle(hWnd : THandle): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SFXAutoExecute(lpCommand, lpParameters : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SFXAutoPasswordPrompt(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Span(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SpanCreateImages(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_SpanSizes(lFirst, lOther : LongInt): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Store(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_Update(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_UseLFN(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

function addZIP_View(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}

{$IFDEF WIN32}
  Const LIBNAME = 'AZIP32.DLL';
{$ELSE}
  Const LIBNAME = 'AZIP16';
{$ENDIF}

implementation

function addZIP: Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_ArchiveName(lpFile : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_BuildSFX(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}  external LIBNAME;

function addZIP_ClearAttributes(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Comment(lpComment : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Delete(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_DeleteComment(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_DisplayComment(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Encrypt(lpPassword : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Exclude(lpFiles : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_ExcludeListFile(lpFile : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Freshen(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_GetLastError: Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_GetLastWarning: Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

Procedure addZIP_GetVersion(var Major : Integer; var Minor : Integer); {$ifdef Win32} stdcall; {$endif Win32}
          external LIBNAME;

function addZIP_Include(lpFiles : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_IncludeFilesNewer(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_IncludeFilesOlder(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_IncludeArchive(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_IncludeDirectoryEntries(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_IncludeHidden(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_IncludeReadOnly(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_IncludeSystem(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_IncludeListFile(lpFile : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

procedure addZIP_Initialise; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_InstallCallback(fCallback: Pointer): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Move(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Overwrite(iFlag : Integer): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Recurse(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Register(lpUserName : PChar; lCode : LongInt): Integer; {$ifdef Win32} stdcall; {$endif Win32}
         external LIBNAME;

function addZIP_SaveAttributes(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_SaveConfiguration(lpFile : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_SaveRelativeTo(lpPath : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_SaveStructure(iFlag : Integer): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_SetArchiveDate(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32}  external LIBNAME;

function addZIP_SetCompressionLevel(iFlag : Integer): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_SetParentWindowHandle(hWnd : THandle): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_SetTempDrive(lppath : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_SetWindowHandle(hWnd : THandle): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_SFXAutoExecute(lpCommand, lpParameters : PChar): Integer; {$ifdef Win32} stdcall; {$endif Win32}
         external LIBNAME;

function addZIP_SFXAutoPasswordPrompt(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Span(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_SpanCreateImages(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_SpanSizes(lFirst, lOther : LongInt): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Store(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_Update(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_UseLFN(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

function addZIP_View(bFlag : Boolean): Integer; {$ifdef Win32} stdcall; {$endif Win32} external LIBNAME;

end.
