*******************************************************************************
*  FILE:         addunzip.h
*
* C/C++ header file for addUNZIP compression libraries
*
* Copyright 1995,1997 Stephen Darlington. All rights reserved.
*  USAGE:        (in a file)
*                #include <addunzip.h>
*
*******************************************************************************


#ifndef _ADDUNZIP_H_
#define _ADDUNZIP_H_

// constants for addUNZIP_Overwrite(...)
#define azOVERWRITE_QUERY 0x0a
#define azOVERWRITE_ALL   0x0b
#define azOVERWRITE_NONE  0x0c

// constants used in messages
#define azLIBRARY_ADDUNZIP 1

// constants for addUNZIP_RestoreAttributes(...)
#define azATTR_NONE 0
#define azATTR_READONLY 1
#define azATTR_HIDDEN 2
#define azATTR_SYSTEM 4
#define azATTR_ARCHIVE 32
#define azATTR_ALL 39

// addZIP & addUNZIP messages
#define AM_SEARCHING      0x0a
#define AM_ZIPCOMMENT     0x0b
#define AM_ZIPPING        0x0c
#define AM_ZIPPED         0x0d
#define AM_UNZIPPING      0x0e
#define AM_UNZIPPED       0x0f
#define AM_TESTING        0x10
#define AM_TESTED         0x11
#define AM_DELETING       0x12
#define AM_DELETED        0x13
#define AM_DISKCHANGE     0x14
#define AM_VIEW           0x15
#define AM_ERROR          0x16
#define AM_WARNING        0x17
#define AM_QUERYOVERWRITE 0x18
#define AM_COPYING        0x19
#define AM_COPIED         0x1a
//#define AM_REPAIRING      0x1b
//#define AM_FILECOMMENT    0x1c
//#define AM_PASSWORD       0x1d
#define AM_ABORT          0xff

// Constants for compression method in AM_VIEW
#define azCM_NONE 0              0x00
#define azCM_SHRUNK              0x0a
#define azCM_REDUCED_1           0x14
#define azCM_REDUCED_2           0x1e
#define azCM_REDUCED_3           0x28
#define azCM_REDUCED_4           0x32
#define azCM_IMPLODED            0x3c
#define azCM_TOKENISED           0x46
#define azCM_DEFLATED_NORMAL     0x50
#define azCM_DEFLATED_MAXIMUM    0x51
#define azCM_DEFLATED_FAST       0x52
#define azCM_DEFLATED_SUPERFAST  0x53
#define azCM_UNKNOWN             0xff

//Constants for whether file is encrypted or not in AM_VIEW
#define azFT_NOT_ENCRYPTED 0x00
#define azFT_ENCRYPTED     0x01

//Constants for whether file is text or binary in AM_VIEW
#define azFT_TEXT   0x00
#define azFT_BINARY 0x01

// Constants used in returning from a AM_QUERYOVERWRITE message
#define azOW_YES        0x00
#define azOW_YES_TO_ALL 0x01
#define azOW_NO         0x02
#define azOW_NO_TO_ALL  0x03

EXTERN CLONG addUNZIP( CVOID ) AUNZIP32
EXTERN CWORD addUNZIP_Abort( CWORD ) AUNZIP32
EXTERN CWORD addUNZIP_ArchiveName( CSTRING ) AUNZIP32
EXTERN CWORD addUNZIP_Decrypt( CSTRING ) AUNZIP32
EXTERN CWORD addUNZIP_DisplayComment( CWORD ) AUNZIP32
EXTERN CWORD addUNZIP_Exclude( CSTRING ) AUNZIP32
EXTERN CWORD addUNZIP_ExcludeListFile( CSTRING ) AUNZIP32
EXTERN CWORD addUNZIP_ExtractTo( CSTRING ) AUNZIP32
EXTERN CWORD addUNZIP_Freshen( CWORD ) AUNZIP32
EXTERN CWORD addUNZIP_GetLastError( CVOID ) AUNZIP32
EXTERN CWORD addUNZIP_GetLastWarning( CVOID ) AUNZIP32
EXTERN CWORD addUNZIP_Include( CSTRING ) AUNZIP32
EXTERN CWORD addUNZIP_IncludeListFile( CSTRING ) AUNZIP32
EXTERN CVOID addUNZIP_Initialise( CVOID ) AUNZIP32
EXTERN CWORD addUNZIP_Overwrite( CWORD ) AUNZIP32
EXTERN CWORD addUNZIP_RestoreAttributes( CWORD ) AUNZIP32
EXTERN CWORD addUNZIP_RestoreStructure( CWORD ) AUNZIP32
EXTERN CWORD addUNZIP_SetParentWindowHandle( CHANDLE ) AUNZIP32
EXTERN CWORD addUNZIP_SetWindowHandle( CHANDLE ) AUNZIP32
EXTERN CWORD addUNZIP_Test( CWORD ) AUNZIP32
EXTERN CWORD addUNZIP_Update( CWORD ) AUNZIP32
EXTERN CWORD addUNZIP_View( CWORD ) AUNZIP32
EXTERN CWORD addUNZIP_SaveConfiguration( CSTRING ) AUNZIP32

#endif

