*-----------------------------------------------------------------------------
*       Module: ZIPIT.PRG             Author: Craig Veal
*  Description: SAMPLE routine to demonstrate AddZip and AddUnZip
*       Tester: Craig Veal            Documentation: Craig Veal
*      Created: 12/29/97      0:35:39AM
* Last updated: 01/24/98      11:52:11AM
*    Copyright: None.  Donated To Public Domain 01/24/98
*                      by Craig Veal & Gator Custom Software
*-----------------------------------------------------------------------------
PARAM lRestore

LOCAL f
PRIVATE lAbort
PRIVATE cLocation1                               && Destination
PRIVATE cLocation2                               && Source
cLocation1 = ""                                  && Destination
cLocation2 = ""                                  && Source
lAbort = .F.
f = NEW ZIPITFORM()
f.mdi = .F. && ensure not MDI
f.Top = -300
IF lRestore
   f.Text = "Restoring Data"
   f.text1.text = "Source"
   f.text2.text = "Destination Drive"
ELSE
   f.Text = "Backing Up Data"
   f.text1.text = "Destination Drive"
   f.text2.text = "Source"
ENDIF
f.entryfield1.value = "A"
f.entryfield2.value = SET("DIRECTORY")
f.ReadModal()
f.Release()
IF .NOT. lAbort
   IF lRestore
      RESTORE_DATA( cLocation1, cLocation2 )
   ELSE
      BACKUP_DATA( cLocation2, cLocation1 )
   ENDIF
ENDIF
RETURN
** END HEADER -- do not remove this line*
* Generated on 12/29/1997
*
parameter bModal
local f
f = new ZIPITFORM()
if (bModal)
   f.mdi = .F. && ensure not MDI
   f.ReadModal()
else
   f.Open()
endif
CLASS ZIPITFORM OF FORM
   SET PROCEDURE TO C:\VISUALDB\SAMPLES\BUTTONS.CC ADDITIVE
   this.OnOpen = CLASS::FORM_ONOPEN
   this.Left = 33
   this.OnClose = {|| .F.}
   this.Text = ""
   this.Top = 0
   this.Height = 6.9492
   this.Width = 60

   DEFINE TEXT TEXT1 OF THIS;
       PROPERTY;
         Left 0.75,;
         Alignment 5,;
         FontSize 10,;
         Text "Destination Drive",;
         Top 0.4473,;
         FontBold .F.,;
         Height 1,;
         Width 16.875

   DEFINE TEXT TEXT2 OF THIS;
       PROPERTY;
         Left 0.75,;
         Alignment 5,;
         FontSize 10,;
         Text "Source",;
         Top 2,;
         FontBold .F.,;
         Height 1,;
         Width 16.875

   DEFINE ENTRYFIELD ENTRYFIELD1 OF THIS;
       PROPERTY;
         Left 18.625,;
         FontSize 10,;
         MaxLength 1,;
         Picture "!",;
         Function "A",;
         Top 0.4473,;
         Value "A",;
         FontBold .F.,;
         Height 1.2002,;
         Border .F.,;
         Width 3.5

   DEFINE ENTRYFIELD ENTRYFIELD2 OF THIS;
       PROPERTY;
         Left 18.625,;
         FontSize 10,;
         MaxLength 60,;
         Function "!",;
         Top 2,;
         Value "",;
         FontBold .F.,;
         Height 1.1973,;
         Border .F.,;
         Width 40.125

   DEFINE OKBUTTON OKBUTTON1 OF THIS;
       PROPERTY;
         OnGotFocus CLASS::BUTTON_GOTFOCUS,;
         OnLostFocus CLASS::BUTTON_LOSTFOCUS,;
         Left 6.125,;
         Top 4.3477,;
         OnClick CLASS::OKBUTTON1_ONCLICK,;
         Group .T.,;
         Height 1.5,;
         Width 14.125

   DEFINE CANCELBUTTON CANCELBUTTON1 OF THIS;
       PROPERTY;
         OnGotFocus CLASS::BUTTON_GOTFOCUS,;
         OnLostFocus CLASS::BUTTON_LOSTFOCUS,;
         Left 36.75,;
         Top 4.3477,;
         OnClick CLASS::CANCELBUTTON1_ONCLICK,;
         Group .T.,;
         Height 1.5,;
         Width 14.125

   PROCEDURE ENTRYFIELD1_VALID
   IF EMPTY( form.entryfield1.value )
      MSGBOX(IIF( lRestore, "Source","Destination")+" MUST Be Provided")
      RETURN .F.
   ELSE
     RETURN .T.
   ENDIF
   RETURN .F.
   ***  EOP:

   PROCEDURE FORM_ONOPEN
   form.entryfield1.setfocus()
   CENTERFORM( this )
   ***  EOP:  FORM_ONOPEN()

   PROCEDURE OKBUTTON1_ONCLICK
   lAbort = .F.
   IF .NOT. CLASS::ENTRYFIELD1_VALID()
      form.entryfield1.setfocus()
      RETURN
   ENDIF
   IF EMPTY(form.entryfield2.value)
      MSGBOX(IIF( lRestore, "Destination","Source")+" MUST Be Provided")
      form.entryfield2.value = SET("DIRECTORY")
      form.entryfield2.setfocus()
      RETURN
   ENDIF
   form.canclose = {||.T. }
   cLocation1 = form.entryfield1.value
   cLocation2 = form.entryfield2.value
   form.close()
   ***  EOP:  OKBUTTON1_ONCLICK()

   Procedure CANCELBUTTON1_OnClick
   lAbort = .T.
   form.canclose = {||.T. }
   form.Close()
   ***  EOP:  CANCELBUTTON1_ONCLICK()

   PROCEDURE BUTTON_GOTFOCUS
   CLASS::BUTTON_LOSTFOCUS()
   form.activecontrol.colornormal = "N/BG+"
   ***  EOP:  BUTTON_GOTFOCUS()


   PROCEDURE BUTTON_LOSTFOCUS
   form.okbutton1.colornormal = "BtnText/BtnFace"
   form.cancelbutton1.colornormal = "BtnText/BtnFace"
   ***  EOP:  BUTTON_LOSTFOCUS()

ENDCLASS

   PROCEDURE BACKUP_DATA
   * ZIP data files here
   PARAM cLoc1, cLoc2

   LOCAL nHandle
   LOCAL nRetCode
   LOCAL cSource
   LOCAL cDestination

   aTables = NEW ARRAY()
   cDestination = "~~:\MYBACKUP.ZIP"          && Change the filename if desired
   cSource = "~~\*.DB*|~~\*.MDX|~~*.INI"
   cSource = STRTRAN( cSource, "~~", cLoc1 )
   cSource = STRTRAN( cSource, "\\", "\" )
   cDestination = STRTRAN( cDestination, "~~", cLoc2 )
   IF FILE( cDestination )
      IF MSGBOX("Erase The Old Backup File?", "", 36 ) = 6
         ERASE ( cDestination )
      ENDIF
   ENDIF
   LOAD DLL AZIP16.DLL
*********************************************************************
*  ADDZIP API CALLS
*********************************************************************
   EXTERN CLONG addZIP( CVOID ) AZIP16
   EXTERN CVOID addZIP_Initialise( CVOID ) AZIP16
   EXTERN CWORD addZIP_ABORT( CWORD ) AZIP16
   EXTERN CWORD addZIP_ArchiveName( CSTRING ) AZIP16
   EXTERN CWORD addZIP_Exclude( CSTRING ) AZIP16
   EXTERN CWORD addZIP_Include( CSTRING ) AZIP16
   EXTERN CWORD addZIP_Recurse( CWORD ) AZIP16
   EXTERN CWORD addZIP_SetParentWindowHandle( CHANDLE ) AZIP16
   EXTERN CWORD addZIP_Span( CWORD ) AZIP16
   EXTERN CWORD addZIP_UseLFN( CWORD ) AZIP16
   EXTERN CWORD addZIP_SetParentWindowHandle( CHANDLE ) AZIP16

   CLOSE TABLES
   ADDZIP_INITIALISE()
   nRetVal = ADDZIP_USELFN( 1 )
   ADDZIP_ARCHIVENAME( cDestination )
   ADDZIP_INCLUDE( cSource )
   ADDZIP_EXCLUDE("ZIPCODE*.*")
   ADDZIP_RECURSE(0)
   ADDZIP_SPAN(1)
* If you have  it, display a wait message for your users here   
   ADDZIP_SETPARENTWINDOWHANDLE( f.hwnd )
   nRetValue = addZIP()
   IF nRetValue < 1
      addZIP_ABORT(1)
   ENDIF
* close your wait message here
   RELEASE DLL AZIP16.DLL
   ***  EOP:  BACKUP_DATA()

   PROCEDURE RESTORE_DATA
   * UNZIP data files here
   PARAM cLoc1, cLoc2

   LOCAL cSource
   LOCAL cDestination
   LOCAL nHandle
   LOCAL nRetCode
   cSource = "~~:\MYBACKUP.ZIP"         && Change the filename if desired
   cDestination = cLoc2
   cSource = STRTRAN( cSource, "~~", cLoc1 )
   IF .NOT. FILE( cSource )
      MSGBOX("Backup File "+cSource+" NOT Found")
      RETURN
   ENDIF
   SLEEP 2
   LOAD DLL AUNZIP16.DLL
*********************************************************************
*  ADDUNZIP API CALLS
*********************************************************************
   EXTERN CLONG addUNZIP( CVOID ) AUNZIP16
   EXTERN CVOID addUNZIP_Initialise( CVOID ) AUNZIP16
   EXTERN CWORD addUNZIP_ABORT( CWORD ) AUNZIP16
   EXTERN CWORD addUNZIP_ArchiveName( CSTRING ) AUNZIP16
   EXTERN CWORD addUNZIP_ExtractTo( CSTRING ) AUNZIP16
   EXTERN CWORD addUNZIP_Include( CSTRING ) AUNZIP16
   EXTERN CWORD addUNZIP_Overwrite( CWORD ) AUNZIP16
   EXTERN CWORD addUNZIP_RestoreStructure( CWORD ) AUNZIP16
   EXTERN CWORD addUNZIP_SetParentWindowHandle( CHANDLE ) AUNZIP16

   CLOSE TABLES
   addUNZIP_Initialise()
   addUNZIP_ArchiveName( cSource )
   addUNZIP_Include("*.*")
   addUNZIP_RestoreStructure(0)
   addUNZIP_ExtractTo( cDestination )
   addUNZIP_Overwrite(11)
* If you have  it, display a wait message for your users here   
   ADDUNZIP_SETPARENTWINDOWHANDLE( f.hwnd )
   nRetValue = addUNZIP()
   IF nRetValue < 1
      addUNZIP_ABORT(1)
   ENDIF
* close your wait message here
   RELEASE DLL AUNZIP16.DLL
   ***  EOP:  RESTORE_DATA()


*-----------------------------------------------------------------------------
*       Module: STRTRAN.PRG           Author: Craig Veal
*  Description: Replaces all occurances of a substring with new substring
*       Tester: Craig Veal            Documentation: Craig Veal
*      Created: 9/13/97       11:05:18PM
* Last updated: 9/13/97      11:05:18PM
*    Copyright: (c) 1997 by Craig Veal & Gator Custom Software
*-----------------------------------------------------------------------------
FUNCTION STRTRAN
PARAM cString, cChar2Fix, cCorrection

LOCAL nPsn
LOCAL nBadLen

IF TYPE("cString") # "C"
   RETURN ""
ENDIF
IF TYPE("cChar2Fix") # "C"
   RETURN cString
ENDIF
IF TYPE("cCorrection") # "C"
   RETURN cString
ENDIF
nBadLen = LEN( cChar2Fix)
nPsn = AT( cChar2Fix, cString )
IF nPsn > 0
	DO WHILE nPsn > 0
     cString = STUFF( cString, nPsn, nBadLen, cCorrection)
     nPsn = AT( cChar2Fix, cString )
	ENDDO
ENDIF
RETURN cString
***  EOP: STRTRAN()



